﻿//-----------------------------------------------
//API for TUSB-INS8/8 Driver
//Visual C# Module
//
//Jan. 31 2014
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//'-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBINS88
{
    [DllImport("TUSBINS8.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins88_Device_Open(short id);
    [DllImport("TUSBINS8.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbins88_Device_Close(short id);
    [DllImport("TUSBINS8.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins88_Write(short id, byte dat);
    [DllImport("TUSBINS8.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins88_Read(short id, out byte dat);
    [DllImport("TUSBINS8.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins88_EdgeSet(short id, byte dat, byte time);
    [DllImport("TUSBINS8.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins88_EdgeRead(short id, out byte dat);

    public static string GetOpenErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            default:
                return "不明なエラーです";
        }
    }

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "このデバイスはオープンされていません";
            case 2:
                return "失敗しました";
            default:
                return "不明なエラーです";
        }
    }
}
