﻿'-----------------------------------------------
'API for TUSB-INS8/8 Driver
'Visual Basic Module
'
'Jan. 31 2014
'Copyright (C) 2014 Turtle Industry Co.,Ltd.
'-----------------------------------------------

Imports System.Runtime.InteropServices

Module TUSBINS8
    <DllImport("TUSBINS8.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbins88_Device_Open(ByVal id As Short) _
                                    As Short
    End Function
    <DllImport("TUSBINS8.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub Tusbins88_Device_Close(ByVal id As Short)
    End Sub
    <DllImport("TUSBINS8.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbins88_Write(ByVal id As Short, _
                             ByVal dat As Byte) _
                         As Short
    End Function
    <DllImport("TUSBINS8.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbins88_Read(ByVal id As Short, _
                            ByRef dat As Byte) _
                        As Short
    End Function
    <DllImport("TUSBINS8.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbins88_EdgeSet(ByVal id As Short, _
                               ByVal dat As Byte, _
                               ByVal time As Byte) _
                           As Short
    End Function
    <DllImport("TUSBINS8.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbins88_EdgeRead(ByVal id As Short, _
                                ByRef dat As Byte) _
                            As Short
    End Function
    ' Error Message (Open Function)
    Public Sub Tusbins88_OpenErrorDisp(ByVal ErrCode As Short)
        Dim Message As String

        Select Case ErrCode
            Case 0
                Message = "正常に終了しました"
            Case 1
                Message = "ID番号が不正です"
            Case 3
                Message = "すでにデバイスはオープンされています"
            Case 4
                Message = "接続されている台数が多すぎます"
            Case 5
                Message = "オープンできませんでした"
            Case 6
                Message = "デバイスが見つかりませんでした"
            Case Else
                Message = "不明なエラーです"
        End Select

        MessageBox.Show(Message)
    End Sub
    ' Error Message
    Public Sub Tusbins88_ErrorDisp(ByVal ErrCode As Short)
        Dim Message As String

        Select Case ErrCode
            Case 0
                Message = "正常に終了しました"
            Case 1
                Message = "このデバイスはオープンされていません"
            Case 2
                Message = "失敗しました"
            Case Else
                Message = "不明なエラーです"
        End Select

        MessageBox.Show(Message)
    End Sub
End Module